//                    C++ DLL
//    LONG version
//
//      VB      C++
//    integer  short  2 bytes
//    double   double 8 bytes
//    long     int    4 bytes
//    single   float  4 bytes
//
 
#include <afx.h>
#include <windows.h>
 
double _stdcall bytesToDouble(unsigned char *cc) {
//*************************************************************
//   Returns the 8 bytes in "cc" as a double.
//
//   To use in VB:
//    Private Declare Function byteToFloat Lib _
//      "C:\vbb\gps\debug\byt2flt.dll" _
//           (ByRef cc As B8) As Double
//
//   TO CREATE DLL:
//       File  -->  New  --> Win32 dynamic link library
//           create an empty project
//       Project -->  Add to Project  -->  Files:
//              byt2flt.cpp
//              byt2flt.def
//       Build dll
//
//
//
//   B8 - Data Type as:
//           Private Type B8
//              bb(7) As Byte
//           End Type
//
//   Need to create a .def file as:
//    LIBRARY  "Gps.DLL"
//
//  EXPORTS
//   bytesToDouble   @1  {@1 is a unique id for the linker}
//
//*************************************************************
   double f;
 
   f = * (double *)cc;
   return(f);
}
 
 
 
 
void _stdcall doubleToBytes(double *d, unsigned char *bb) {
//*************************************************************
//   Returns the 8 bytes in "d" as an array of bytes in "bb".
//*************************************************************
   int i;
   unsigned char *c;
 
   c=(unsigned char *)d;
 
   for(i=0; i<8; i++)
       bb[i]= c[i];
}
 
 
 
long _stdcall bytesToLong(unsigned char *cc) {
//*************************************************************
//   Returns the 4 bytes in "cc" as a long
//*************************************************************
   long f;
 
   f = * (long *)cc;
   return(f);
}
 
 
 
void _stdcall longToBytes(long *d, unsigned char *cc) {
//*************************************************************
//   Returns the 4 bytes in "d" as an array of bytes in "cc".
//*************************************************************
   int i;
   unsigned char *c;
 
   c=(unsigned char *)d;
 
   for(i=0; i<4; i++)
       cc[i]= c[i];
}
 
 
 
void _stdcall memToMem(unsigned char *from, unsigned char *to, int n) {
//*******************************************************************
//   Copies "n" bytes from "from" to "to".
//*******************************************************************
   int i;
 
   for(i=0; i<n; i++)
       to[i]= from[i];
}
 
void _stdcall bitsub( BITMAP *p) {
    //   struct tagBITMAP *p
//*******************************************************************
//
//*******************************************************************
   int i, pos;
   unsigned char * data;
 
   data = (unsigned char *) p->bmBits;
 
   pos = 0;
   for(i=0; i<200; i++) {
       data[pos] = 255;
       data[pos+1] = 0;
       data[pos+2] = 0;
       pos = pos + 3;
   }
}
 
 
 
void _stdcall count1(struct tagBITMAP *p, int &n, int m) {
//*******************************************************************
//    returns a count of # certain colors  or  BITMAP *p
//*******************************************************************
   int i;
   unsigned char * data;
 
   data = (unsigned char *) p->bmBits;
 
   n=0;
   for(i=0; i<m; i++) {
       if(data[i] == 241) n++;
   }
 
}
 
 
void _stdcall count2(unsigned char *cc, int &n, int m) {
//*******************************************************************
//    returns a count of # certain colors
//*******************************************************************
   int i;
 
   n=0;
   for(i=0; i<m; i++) {
       if(cc[i] == 241) n++;
   }
 
}
 
 
 
 
 
int _stdcall GetDIBits1(struct HDC__ * hdc, struct HBITMAP__ * hbmp,
                        int s1, int s2,
                        unsigned char *data, BITMAPINFO * bmih,
                        int usage) {
//*******************************************************************
//    returns a count of # certain colors
//*******************************************************************
//   BITMAPINFOHEADER bmih;
 
/*
typedef struct tagBITMAPINFOHEADER{ // bmih
    DWORD  biSize;
    LONG   biWidth;
    LONG   biHeight;
    WORD   biPlanes;
    WORD   biBitCount
    DWORD  biCompression;
    DWORD  biSizeImage;
    LONG   biXPelsPerMeter;
    LONG   biYPelsPerMeter;
    DWORD  biClrUsed;
    DWORD  biClrImportant;
} BITMAPINFOHEADER;
*/
   int r = GetDIBits(hdc, hbmp, s1, s2, data, bmih, usage);
   return(r);
}
 
 
 
void _stdcall setsomecolors(unsigned char * cc, int m) {
//*******************************************************************
//   Sets " m" some colors
//*******************************************************************
   int i;
 
   int p = 300;
   for(i=0; i<m; i++) {
       cc[p]=255;
       cc[p+1]=0;
          cc[p+2]=0;
       p=p+3;
   }
}
 
 
 
int _stdcall return1() {
//*******************************************************************
//
//*******************************************************************
   return(BITSPIXEL);  // return(BI_RGB);
}
 
 
 
 
 
HBITMAP _stdcall ShowImage(HWND hwnd, char * databytes,
                           BITMAPINFOHEADER &bmInfo,
                           int x, int y, int w, int h) {
//*****************************************************************
//   BUILDS A DDP (Device Dependent Bitmap) and displays it.
//
//   Shows the image with "databytes" and "bmInfo" on "hwnd", "hdc".
//   Destination (hwnd, hdc) can be picturebox, form, etc.
//
//   hwnd - handle of destination window
//   hdc  - dc of destination (or compatible)
//   databytes - hold the rgb data bytes (3 bytes per pixel)
//   bmInfo    - the bitMapInfoHeader data associated with "databytes"
//   x,y   - where to start on destination window
//   w,h   - width and height of image to dispaly (can be smaller
//           than actual image size)
//         =-1 or > image w,h, actual image width/height are used
//
//*****************************************************************
 
     static HBITMAP      hBitmap ;
     BITMAP              bitmap ;
      HDC                 hdcMem ;
     HDC                 hdc;
     PAINTSTRUCT         ps ;
 
//             MessageBox (hwnd, TEXT ("test1"),
//                    "BOB", MB_OK | MB_ICONEXCLAMATION) ;
 
 
     if (hBitmap) {
        DeleteObject (hBitmap) ;
        hBitmap = NULL ;
     }
 
     hdc = GetDC (hwnd) ;
 
   // Create the DDB from the DIB
   //===== Contray to the name, creates a device DEPENDENT bitmap from a
   //===== DIB (device independent bitmap)
     hBitmap = CreateDIBitmap (hdc,
                               &bmInfo,
                               CBM_INIT,
                               databytes,
                               (BITMAPINFO *) &bmInfo,
                               DIB_RGB_COLORS) ;
 
     ReleaseDC (hwnd, hdc) ;
 
     // Invalidate the client area for later update
     //   Needed, else paint message not issued and images not shown!
     InvalidateRect (hwnd, NULL, TRUE) ;
 
     if (hBitmap == NULL) {
        MessageBox (hwnd, TEXT ("Cannot load DIB file"),
                                "BOB", MB_OK | MB_ICONEXCLAMATION) ;
     }
 
     hdc = BeginPaint (hwnd, &ps) ;
 
     if (hBitmap) {
        GetObject (hBitmap, sizeof (BITMAP), &bitmap) ;
 
        hdcMem = CreateCompatibleDC (hdc) ;
        SelectObject (hdcMem, hBitmap) ;
 
        if (w == -1 || w > bmInfo.biWidth) w = bmInfo.biWidth;
        if (h == -1 || h > bmInfo.biHeight) h = bmInfo.biHeight;
 
        BitBlt (hdc,    x,y, w,h,  hdcMem, 0, 0, SRCCOPY) ;
 
        DeleteDC (hdcMem) ;
     }
 
     EndPaint (hwnd, &ps) ;
 
//     if (hBitmap) DeleteObject (hBitmap);
     return hBitmap ;
}
 
 
 
 
 
 
HBITMAP _stdcall BuildDDBitmap(HWND hwnd, char * databytes,
                                BITMAPINFOHEADER &bmInfo) {
//*****************************************************************
//   BUILDS A DDP (Device Dependent Bitmap).
//   Returns a handle to the DDP bit map
//
//   bitmap can be displayed by calling "PaintIt"
//
//   hwnd - handle of window associated with the bitmap
//   databytes - hold the rgb data bytes (3 bytes per pixel)
//   bmInfo    - the bitMapInfoHeader data associated with "databytes"
//
//*****************************************************************
     //static HBITMAP      hBitmap ;
     HBITMAP      hBitmap ;
     HDC                 hdc;
 
//     if (hBitmap) {
//        DeleteObject (hBitmap) ;
//        hBitmap = NULL ;
//     }
 
     hdc = GetDC (hwnd) ;
 
   // Create the DDB from the DIB
   //===== Contray to the name, creates a device DEPENDENT bitmap from a
   //===== DIB (device independent bitmap)
     hBitmap = CreateDIBitmap (hdc,
                               &bmInfo,
                               CBM_INIT,
                               databytes,
                               (BITMAPINFO *) &bmInfo,
                               DIB_RGB_COLORS) ;
 
     ReleaseDC (hwnd, hdc) ;
 
     return hBitmap ;
}
 
 
 
 
 
 
 
void _stdcall PaintIt(HWND hwnd, HBITMAP hBitmap,
                      BITMAPINFOHEADER &bmInfo,
                      int x, int y, int w, int h) {
 
     BITMAP   bitmap;
     HDC      hdc;
     HDC      hdcMem;
     PAINTSTRUCT   ps;
 
     InvalidateRect (hwnd, NULL, TRUE) ;
 
     hdc = BeginPaint (hwnd, &ps) ;
 
     if (hBitmap) {
        GetObject (hBitmap, sizeof (BITMAP), &bitmap) ;
 
        hdcMem = CreateCompatibleDC (hdc) ;
        SelectObject (hdcMem, hBitmap) ;
 
        //   just for fun
        //TextOut(hdcMem, 50,50,"Testing",7);
 
        if (w == -1 || w > bmInfo.biWidth) w = bmInfo.biWidth;
        if (h == -1 || h > bmInfo.biHeight) h = bmInfo.biHeight;
 
        BitBlt (hdc,    x,y, w,h,  hdcMem, 0, 0, SRCCOPY) ;
 
        DeleteDC (hdcMem) ;
     }
 
     EndPaint (hwnd, &ps) ;
}
 
 
 
 
void _stdcall TextOut1(HDC hdc, int x, int y, char *str, int strlen) {
   TextOut(hdc, x,y, str, strlen);
}
 
 
 
 
 
void _stdcall TalkIt(PTSTR pszSpeak) {
  // Speak(PTSTR pszSpeak, 0, NULL);
 
   CoInitialize(NULL); // if you haven't done it already
 
 
 
 
    CoCreateInstance(CLSID_VTxt,
                 NULL,
                 CLSCTX_LOCAL_SERVER,
                 IID_IVoiceText,
                 (LPVOID *)&gpIVTxt);
 
 
 
 
 
}